export declare type ErrorResult = {
    success: false;
    error?: string;
};
export declare type SuccessOrErrorResult<TValue = undefined> = ErrorResult | SuccessResult<TValue>;
export declare type SuccessResult<TValue = undefined> = TValue extends undefined ? {
    success: true;
} : {
    success: true;
    value: TValue;
};
export declare function successResult(): SuccessResult;
export declare function successValueResult<TValue>(value: TValue): SuccessResult<TValue>;
export declare function errorResult(error?: string): ErrorResult;
//# sourceMappingURL=result.d.ts.map